<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb6035043db6d075_67796080/operators/FlowchartOperator_lb6035043db6d075_67796080.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb6035043db6d075_67796080/helpers/TypeOperations_lb6035043db6d075_67796080.php';

class NotEqualOperator_lb6035043db6d075_67796080 extends FlowchartOperator_lb6035043db6d075_67796080
{

    protected $operand1;
    protected $operand2;
    protected $result;

    public function __construct($params)
    {
        parent::__construct($params);
    }

    public function setInDataPorts($params)
    {
        if (!empty($params['inDataPorts']['operand1']['value'])) {
            $this->operand1 = $params['inDataPorts']['operand1']['value'];
        }
        if (!empty($params['inDataPorts']['operand2']['value'])) {
            $this->operand2 = $params['inDataPorts']['operand2']['value'];
        }
        $this->inDataPorts = array(
            'operand1' => array('id' => 'operand1'),
            'operand2' => array('id' => 'operand2')
        );
    }

    public function setInDataPortById($id, $value)
    {
        if ($id == 'operand1') {
            $this->operand1 = $value;
        } elseif ($id == 'operand2') {
            $this->operand2 = $value;
        } elseif (!empty($this->inDataPorts[$id])) {
            $this->inDataPorts[$id]['value'] = $value;
        }
    }

    public function getOutDataByPortId($portId)
    {
        return $this->result;
    }

    public function process($params = array())
    {
        if ($this->isBlank($this->operand1) || $this->isBlank($this->operand2)) {
            $this->result = $this->compareBlankOperands($this->operand1, $this->operand2);
            return;
        }
        $type = $this->getType();
        switch ($type) {
            case 'date':
                $operand1 = TypeOperations_lb6035043db6d075_67796080::getDatetime($this->operand1);
                $operand2 = TypeOperations_lb6035043db6d075_67796080::getDatetime($this->operand2);
                break;
            case 'number':
                $operand1 = TypeOperations_lb6035043db6d075_67796080::getNumber($this->operand1);
                $operand2 = TypeOperations_lb6035043db6d075_67796080::getNumber($this->operand2);
                break;
            default:
                $operand1 = (string) $this->operand1;
                $operand2 = (string) $this->operand2;
                break;
        }
        if ($this->comparisonWithTypeIsRequired($type, $operand1, $operand2)) {
            $this->result = $this->compareOperandsWithType($operand1, $operand2);
        } else {
            $this->result = $this->compareOperands($operand1, $operand2);
        }
    }

    private function compareBlankOperands($operand1, $operand2)
    {
        if ($this->isBlank($operand1) && $this->isBlank($operand2)) {
            return (isset($operand1) !== isset($operand2));
        }
        if ($this->isBlank($operand1) && !$this->isBlank($operand2)) {
            return true;
        }
        if (!$this->isBlank($operand1) && $this->isBlank($operand2)) {
            return true;
        }
        return false;
    }

    protected function compareOperands($operand1, $operand2)
    {
        return $operand1 != $operand2;
    }

    protected function compareOperandsWithType($operand1, $operand2)
    {
        return $operand1 !== $operand2;
    }

    private function isBlank($value)
    {
        return TypeOperations_lb6035043db6d075_67796080::isBlank($value);
    }

    protected function getType()
    {
        if (TypeOperations_lb6035043db6d075_67796080::isDate($this->operand1) && TypeOperations_lb6035043db6d075_67796080::isDate($this->operand2)) {
            return 'date';
        }
        if (TypeOperations_lb6035043db6d075_67796080::isNumeric($this->operand1) && TypeOperations_lb6035043db6d075_67796080::isNumeric($this->operand2)) {
            return 'number';
        }
        if (TypeOperations_lb6035043db6d075_67796080::isString($this->operand1) && TypeOperations_lb6035043db6d075_67796080::isString($this->operand2)) {
            return 'string';
        }
        return '';
    }

    protected function comparisonWithTypeIsRequired($type, $operand1, $operand2)
    {
        if ($type == 'number' &&
            (
                ($operand1 === '' && $operand2 !== '') ||
                ($operand2 === '' && $operand1 !== '') ||
                ($operand1 === NULL && $operand2 !== NULL) ||
                ($operand2 === NULL && $operand1 !== NULL)
            )
        ) {
            return true;
        }
        return false;
    }

}
